<?php

namespace Teknisa\PLA\Modules\Prato\Controllers;

use Zeedhi\Framework\DTO;

class Pla13100PadraoGrupoDePrato {


    protected $environment;
    protected $connection;
    protected $crudService;

    public function __construct($environment, $connection, $crudService) {
        $this->environment = $environment;
        $this->connection  = $connection;
        $this->crudService = $crudService;
    }

    public function save(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $dataSet = $row['rowsChanged'];
        $queryUpdateGroupPlate = "UPDATE GRUPOPRATO SET 
                                        NMGRUPOPRATO = :NEW_NMGRUPOPRATO,
                                        DTULTATU = SYSDATE, 
                                        NRORGULTATU = :NRORG, 
                                        CDOPERULTATU = :CDOPERADOR
                                    WHERE 
                                        CDGRUPOPRATO = :CDPADGRUPOPRATO AND 
                                        IDTIPORESTRICAO = :IDTIPORESTRICAO AND 
                                        NRORG =:NRORG";
        $this->connection->beginTransaction();
        try {
            $this->crudService->save('padgrupoprato', $dataSet);
            foreach($dataSet as $cRow){
                $stmt = $this->connection->prepare($queryUpdateGroupPlate);
                $params = array(
                    'NEW_NMGRUPOPRATO' => $cRow['NMPADGRUPOPRATO'],
                    'CDPADGRUPOPRATO'  => $cRow['CDPADGRUPOPRATO'],
                    'IDTIPORESTRICAO'  => $row['IDTIPORESTRICAO'],
                    'NRORG'            => $this->environment->getNrOrg(),
                    'CDOPERADOR'       => $this->environment->getCdOperador()
                );
                $stmt->execute($params);
            }
            $this->connection->commit();
        } catch (\Exception $e){
            $this->connection->rollback();
            $response->setError($e->getMessage());
        }
    }
} 
